#ifndef __INIT_H
#define __INIT_H


#include <rtems.h>


#define CONFIGURE_RTEMS_INIT_TASKS_TABLE

#define CONFIGURE_MAXIMUM_SEMAPHORES 10
#define CONFIGURE_MAXIMUM_TASKS      10

#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER

#define CONFIGURE_APPLICATION_DOES_NOT_NEED_CLOCK_DRIVER


//! \brief Fatal Extension, called when things have gone horribly wrong and we're crashing
//!
//! See http://rtems.org/onlinedocs/doc-current/share/rtems/html/c_user/User-Extensions-Manager-FATAL-Error-Extension.html [Accessed: 2013-08-07]
void fatal_extension(Internal_errors_Source the_source,
                     bool                   is_internal,
                     Internal_errors_t      the_error);

#define CONFIGURE_INITIAL_EXTENSIONS { .fatal = fatal_extension } //!< Install the Fatal Extension


#define CONFIGURE_CONFDEFS_DEBUG // Debug RTEMS static configuration

#define CONFIGURE_STACK_CHECKER_ENABLED // Enable the RTEMS Stack Checker


#include <rtems/confdefs.h>


#endif // __INIT_H

