// I've just sprayed headers from cpukit/rtems/src/semrelease.c...
#include <rtems/system.h>
#include <rtems/rtems/status.h>
#include <rtems/rtems/support.h>
#include <rtems/rtems/attrimpl.h>
#include <rtems/score/isr.h>
#include <rtems/rtems/options.h>
#include <rtems/rtems/semimpl.h>
#include <rtems/score/coremuteximpl.h>
#include <rtems/score/coresemimpl.h>
#include <rtems/score/thread.h>

#include <rtems/score/interr.h>

#include <assert.h>

#include "semcount.h"


//! \todo Undodgify (e.g., handle more than LOCAL semaphores, understand _Semaphore_Get() et al.) and submit to RTEMS?
//!
//! \warning Don't call from an ISR (I think...)
uint32_t rtems_semaphore_count(rtems_id id)
{
	uint32_t          count;
	Objects_Locations location;
	Semaphore_Control *semaphore = _Semaphore_Get(id, &location);


	assert(location == OBJECTS_LOCAL);
	assert(semaphore);


	count = _CORE_semaphore_Get_count(&semaphore->Core_control.semaphore);


	_Objects_Put(&semaphore->Object);


	return (count);
}

